@echo off
rem ===========================================================================
echo EAAddinSetup.bat o[W3.13
rem Copyright(C) 2010-2020 Sparx Systems Japan Co., Ltd. All rights Reserved.
rem ===========================================================================
rem p[^
rem Ȃ  : AhCCXg[
rem /u    : AhCACXg[
rem /u /f : AhCACXg[iEArhԍ`FbNj
rem ===========================================================================

setlocal

set result=0

rem  p[^擾 
IF not "%1"=="/u" (
 set SetupKind=add
 set /a delCounter=-1
 set Message=o^
 set SkipRequireProcess=0
) ELSE (
 set SetupKind=del
 set /a delCounter=1
 set Message=폜
 IF not "%2"=="/f" (
   set SkipRequireProcess=0
 ) ELSE (
   set SkipRequireProcess=1
 )
)

rem  EACXg[pX擾 
for /f "tokens=4,5,6,7,8,9,10*" %%i in ('%windir%\system32\reg.exe query "HKCU\Software\Sparx Systems\EA400\EA" /v "Install Path"') do set EAInstallPath=%%i %%j %%k %%l %%m %%n %%o
:LOOP
IF "%EAInstallPath%"=="" (goto err1)
IF not "%EAInstallPath:~-1%"==" " (GOTO NEXT) else set EAInstallPath=%EAInstallPath:~0,-1%
GOTO LOOP
:NEXT
IF not EXIST "%EAInstallPath%" (goto err1)
IF not EXIST "%EAInstallPath%\EA.exe" (goto err1)

rem  EAo[W擾 
"%EAInstallPath%\EA.exe" /register
for /f "tokens=3" %%i in ('%windir%\system32\reg.exe query "HKCU\Software\Sparx Systems\EA400\EA" /v "Version"') do set EAVersionFull=%%i
set EAVersion=%EAVersionFull:~0,2%
set EAVersion=%EAVersion:.=%
set EABuild=%EAVersionFull:~-4%
set EABuild=%EABuild:.=%

rem  ANZXmF 
copy nul "%EAInstallPath%\addin.tmp" > nul 2>&1
IF not %errorlevel%==0 (goto err2)
del /F "%EAInstallPath%\addin.tmp"

rem  ݂̃pX擾 
cd /d %~dp0
set CurrentPath=%cd%

rem  init@Cǂݍ 

rem CXg[F擪ss
IF %SetupKind%==add (
 for /f "tokens=1,2,3,4,5,6,7*" %%a in (EAAddin.ini) do (call :START %%a %%b %%c %%d %%e %%f %%g)
) ELSE (
rem ACXg[F2init@Cǂݍ݁A1ڂregnR}hE2ڂcopynR}hŃt@C폜
 IF %delCounter%==1 (
  for /f "tokens=1,2,3,4,5,6,7*" %%a in (EAAddin.ini) do (call :START %%a %%b %%c %%d %%e %%f %%g)
  set /a delCounter=delCounter+1
  for /f "tokens=1,2,3,4,5,6,7*" %%a in (EAAddin.ini) do (call :START %%a %%b %%c %%d %%e %%f %%g)
))

rem  ĨbZ[W\ 
echo:
IF %result%==0 (
 echo -----AhC%Message%܂B-----
) ELSE (
 echo -----AhC%Message%Ɏs܂B-----
 echo guV[eBO https://www.sparxsystems.jp/products/EA/tech/EAAddinSetup.htm#trouble
)
pause
exit /b %result%

rem  init@Cݒ擾 
:START
if %result%==2 (goto end_repeat)

rem 
set Header=""
set Command=""
set AddinName=""
set FileName=""
set DLLInfo=""
set RegValue=""
set NoCopy=""

rem init@CZbg
set Header=%1
set Command=%2
set AddinName=%3
set FileName=%4
set DLLInfo=%5
set RegValue=%6
set NoCopy=%7

IF not "%Header%"=="-" (goto end_repeat)
IF %Command%==reg (goto regProcess)
IF %Command%==copy (goto copyProcess)
IF %Command%==xcopy (goto copyProcess)
IF %Command%==shared (goto copyProcess)
IF %Command%==require (goto requireProcess)

echo G[Finit@C1ځiR}hjԈĂ܂BR}hw肵ĂB
goto end_repeat_fail

rem  R}hRs[(copy,xcopy,shared)̏ꍇ 
:copyProcess
IF "%AddinName%"=="" (
echo G[Finit@CcopyR}h2ځiAhCj͂ĂB
goto end_repeat_fail)

IF "%FileName%"=="" (
echo G[Finit@Cw%AddinName%xɊւ3ځit@Cj͂ĂB
goto end_repeat_fail)

IF %SetupKind%==del (goto delProcess)

rem CXg[̏ꍇFtt@C/tH_Rs[
IF %Command%==shared set Command=copy

rem t@CRs[̏ꍇ
IF %Command%==copy (
 echo:
 echo ---w%AddinName%x̕tt@C%FileName%Rs[܂B
 if exist %FileName% echo. > "%FileName%:Zone.Identifier"
 %windir%\system32\xcopy.exe "%FileName%" "%EAInstallPath%" /y /q
)
IF not %errorlevel%==0 (
 echo G[F%FileName%t@C𐳂Rs[łȂ\܂B
 goto end_repeat_fail
)

rem tH_Rs[̏ꍇ
IF %Command%==xcopy (
 echo:
 echo ---w%AddinName%x̕ttH_%FileName%Rs[܂B
 cd /d "%EAInstallPath%"
 mkdir "%FileName%"
 cd "%FileName%"
 %windir%\system32\xcopy.exe "%CurrentPath%\%FileName%" . /y /q
)
IF not %errorlevel%==0 (
 echo G[F%FileName%tH_𐳂Rs[łȂ\܂B
 goto end_repeat_fail
)
cd /d "%CurrentPath%"

rem ΃pX̎w肪ꍇ
IF not "%DLLInfo%"=="" (
 cd /d "%EAInstallPath%"
 IF not exist "%DLLInfo%" (md "%DLLInfo%")
 MOVE /y "%FileName%" "%DLLInfo%"
)
IF not %errorlevel%==0 (
 echo G[F%FileName%t@C𐳂ړłȂ\܂B
 goto end_repeat_fail
)
cd /d "%CurrentPath%"
goto end_repeat

rem ACXg[̏ꍇFtt@C/tH_폜
:delProcess
rem t@C폜̏ꍇ
IF %Command%==copy (
 IF %delCounter%==2 (
  echo:
  echo ---w%AddinName%x̕tt@C%FileName%폜܂B
  cd /d "%EAInstallPath%"
  IF not "%DLLInfo%"=="" (cd "%DLLInfo%")
  del /F %FileName%
  cd /d "%CurrentPath%"
  goto end_repeat
))

rem tH_폜̏ꍇ
IF %Command%==xcopy (
 IF %delCounter%==2 (
  echo:
  echo ---w%AddinName%x̕ttH_%FileName%폜܂B
  cd /d "%EAInstallPath%"
  rmdir /q /s "%FileName%"
  cd /d "%CurrentPath%"
  goto end_repeat
))

goto end_repeat

rem  R}hEArhԍ`FbN(require)̏ꍇ 
:requireProcess
IF %SkipRequireProcess%==0 (
 IF %EABuild% lss %AddinName% (
  echo G[FEArh %AddinName% ȏオKvłB
  cd /d "%CurrentPath%"
  set result=2
  exit /b 0
))

goto end_repeat

rem  R}ho^(reg)̏ꍇ 
:regProcess
rem ACXg[2ڂ̌Ăяo͉Ȃ
IF %SetupKind%==del (
 IF %delCounter%==2 (goto end_repeat)
)
IF "%AddinName%"=="" (
 echo G[Finit@CregR}h2ځiAhCjȍ~͂ĂB
 goto end_repeat_fail
)
IF "%FileName%"=="" (
 echo G[Finit@Cw%AddinName%x3ځiDLLjȍ~͂ĂB
 goto end_repeat_fail
)
IF "%DLLInfo%"=="" (
 echo G[Finit@Cw%AddinName%x4ځiDLLjȍ~͂ĂB
 goto end_repeat_fail
)
IF "%RegValue%"=="" (
 echo G[Finit@Cw%AddinName%x5ځiWXglj͂ĂB
 goto end_repeat_fail
)

rem JñbZ[W\
echo ------------------------------------------
echo w%AddinName%x%Message%܂B
echo ------------------------------------------
rem  DLLEACXg[tH_ɃRs[ 
IF %SetupKind%==add (
IF not "%NoCopy%"=="-" (
%windir%\system32\xcopy.exe "%FileName%" "%EAInstallPath%" /y /q
))
IF not %errorlevel%==0 (
 echo G[F%FileName%t@C𐳂Rs[łȂ\܂B
 goto end_repeat_fail
)

rem  DLLo^Eo^ 
IF "%DLLInfo%"==".Net" (goto DotNetReg)
IF "%DLLInfo%"==".Net2.0" (goto :DotNetRegNext)
IF "%DLLInfo%"==".Net4.0" (goto :DotNetRegNext)
IF "%DLLInfo%"=="not.Net" (goto notDotNetReg)

echo G[Finit@Cw%AddinName%x4ځiDLLj̓esłB
goto end_repeat_fail

:DotNetReg
rem  OS 
ver | find "Version 5.2." > nul
IF not errorlevel 1 goto DotNetRegNext
ver | find "Version 6.0." > nul
IF not errorlevel 1 goto DotNetRegNext
ver | find "Version 6.1." > nul
IF not errorlevel 1 goto DotNetRegNext

if %EAVersion% lss 14 set DLLInfo=.Net4.0

:DotNetRegNext
IF %SetupKind%==add (
 IF not "%DLLInfo%"==".Net4.0" (
  IF %EAVersion% geq 14 (
   echo G[F.Net3.5ȑÕAhCEA14ȍ~ւ̃CXg[ɂ͑ΉĂ܂B
   goto end_repeat_fail
  )
 )
)

rem  regasm pX`FbN 
IF "%DLLInfo%"==".Net4.0" (
 set DotNetRegasm=%SystemRoot%\Microsoft.NET\Framework\v4.0.30319\regasm.exe
) ELSE (
 set DotNetRegasm=%SystemRoot%\Microsoft.NET\Framework\v2.0.50727\regasm.exe
)

IF not EXIST "%DotNetRegasm%" (
 echo G[Finit@CŎw肳ꂽo[W.NetFrameworkCXg[ĂȂ\܂B
 goto end_repeat_fail
)

cd /d "%EAInstallPath%"
IF %SetupKind%==add (
 echo. > "%FileName%:Zone.Identifier"
 "%DotNetRegasm%" "%FileName%"
) ELSE (
 "%DotNetRegasm%" /unregister "%FileName%"
)
IF not %errorlevel%==0 (
 IF %SetupKind%==add (
  echo G[F %FileName%t@Cɑ΂ĐAZuo^c[słȂ\܂B
  goto end_repeat_fail
 ) ELSE (
  echo xF %FileName%t@Cɑ΂ĐAZuo^c[słȂ\܂B
))
cd /d "%CurrentPath%"
goto regImport

cd /d "%CurrentPath%"
goto regImport

:notDotNetReg
cd /d "%EAInstallPath%"
IF %SetupKind%==add (
 echo. > "%FileName%:Zone.Identifier"
 %windir%\system32\regsvr32.exe /s "%FileName%"
) ELSE (
 %windir%\system32\regsvr32.exe /u /s "%FileName%"
)
IF not %errorlevel%==0 (
 IF %SetupKind%==add (
  echo G[F %FileName%t@Cɑ΂ĐAZuo^c[słȂ\܂B
  goto end_repeat_fail
 ) ELSE (
  echo xF %FileName%t@Cɑ΂ĐAZuo^c[słȂ\܂B
))
cd /d "%CurrentPath%"
goto regImport

rem  WXgo^E폜 
:regImport
set RegistoryPath="\Software\Sparx Systems\EAAddins"\%AddinName%

IF EXIST "%SystemRoot%\syswow64\reg.exe" (
 set RegExeFolder="%SystemRoot%\syswow64"
) ELSE (
 set RegExeFolder="%SystemRoot%\system32"
)

IF not "%RegValue%"=="-" (
 IF %SetupKind%==add (
  %RegExeFolder%\reg.exe add HKLM%RegistoryPath% /ve /f /d %RegValue%
 ) ELSE (
  IF %delCounter%==1 (%RegExeFolder%\reg.exe DELETE HKLM%RegistoryPath% /f)
))
IF not %errorlevel%==0 (
 IF %SetupKind%==add (
  goto end_repeat_fail
 ) ELSE (
  echo xF łɃWXg͍폜Ă\܂B
))

IF not "%RegValue%"=="-" (
 IF %SetupKind%==del (
  IF %delCounter%==1 (%RegExeFolder%\reg.exe DELETE HKCU%RegistoryPath% /f > nul 2>&1 )
))

rem  DLLt@C폜 
IF %SetupKind%==del (
 IF not "%NoCopy%"=="-" (
  cd /d "%EAInstallPath%"
  del %FileName% /f
))
IF not %errorlevel%==0 (echo xF łɃt@C͍폜Ă\܂B)
cd /d "%CurrentPath%"

:end_repeat
exit /b 0

:end_repeat_fail
cd /d "%CurrentPath%"
set result=1
exit /b 0

:err1
echo G[F EACXg[pXsłBEAxNAĂēxsĂB
echo guV[eBO https://www.sparxsystems.jp/products/EA/tech/EAAddinSetup.htm#trouble
set result=1
pause
exit /b %result%

:err2
echo G[F ANZX܂BuǗ҂ƂĎsvĂB
set result=1
pause
exit /b %result%
